﻿using FluentValidation;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using WiseJFluentValidation.Model;

namespace WiseJFluentValidation.Validation
{
    public class PersonValidator:AbstractValidator<Person>
    {
        public PersonValidator()
        {
            RuleFor(x => x.FirstName).NotEmpty().WithMessage("FirstName is required.");
            RuleFor(x => x.LastName).Cascade(CascadeMode.Stop).NotEmpty().WithMessage("LastName is required.").Length(3, 80).WithMessage("The length of LastName should be between 3 and 80 characters.");
            RuleFor(x => x.Birthday).LessThan(DateTime.Now).WithMessage("The Birthday should be lower than the current date.");
        }
    }
}