﻿
using FluentValidation.Results;
using Microsoft.Ajax.Utilities;
using System;
using System.Linq;
using Wisej.Web;
using WiseJFluentValidation.Model;
using WiseJFluentValidation.Validation;

namespace WiseJFluentValidation
{
    public partial class Window1 : Form
    {
        private Person _currentitem = new Model.Person { FirstName = "", LastName = "", Birthday = DateTime.Parse("2021-01-01") };

        private ValidationResult _result;
        public Window1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            PersonValidator val = new PersonValidator();
            _result = val.Validate(_currentitem);
            errorProvider1.Clear();
            ValidateChildren();
            if (_result.IsValid)
            {
                AlertBox.Show("The data is valid.");
            }
            else
            {
                AlertBox.Show("The data is not valid.");
            }
        }

        private void textBox1_Validating(object sender, System.ComponentModel.CancelEventArgs e)
        {
            ValidatorManager((TextBox)sender);

        }
        private void textBox2_Validating(object sender, System.ComponentModel.CancelEventArgs e)
        {
            ValidatorManager((TextBox)sender);
        }

        private void ValidatorManager(Control control)
        {
            if (_result?.Errors?.Count > 0)
            {
                string bindingfield = control.DataBindings[0].BindingMemberInfo.BindingField;
                var errors = _result.Errors.Where(x => x.PropertyName == bindingfield).FirstOrDefault();
                if (errors != null)
                {
                    errorProvider1.SetError(control, errors.ErrorMessage);
                }
            }
        }

        private void Window1_Load(object sender, EventArgs e)
        {
            bindingSource1.Add(_currentitem);
        }

        private void dateTimePicker1_Validating(object sender, System.ComponentModel.CancelEventArgs e)
        {
            ValidatorManager((DateTimePicker)sender);
        }
    }
}
